# -*- coding: utf-8 -*-
#
# File: PloneMallCart.py
#
# Copyright (c) 2006 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'


from Products.CMFCore.utils import getToolByName
from Products.ExternalMethod.ExternalMethod import ExternalMethod

##code-section module-header #fill in your manual code here
##/code-section module-header

def installWorkflows(self, package, out):
    """Install the custom workflows for this product."""

    productname = 'PloneMallCart'
    workflowTool = getToolByName(self, 'portal_workflow')

    ourProductWorkflow = ExternalMethod('temp', 'temp',
                                        productname+'.'+'cart_workflow',
                                        'createcart_workflow')
    workflow = ourProductWorkflow(self, 'cart_workflow')
    if 'cart_workflow' in workflowTool.listWorkflows():
        print >> out, 'cart_workflow already in workflows.'
    else:
        workflowTool._setObject('cart_workflow', workflow)
    workflowTool.setChainForPortalTypes(['Cart'], workflow.getId())

    ourProductWorkflow = ExternalMethod('temp', 'temp',
                                        productname+'.'+'cartitem_workflow',
                                        'createcartitem_workflow')
    workflow = ourProductWorkflow(self, 'cartitem_workflow')
    if 'cartitem_workflow' in workflowTool.listWorkflows():
        print >> out, 'cartitem_workflow already in workflows.'
    else:
        workflowTool._setObject('cartitem_workflow', workflow)
    workflowTool.setChainForPortalTypes(['CartItem'], workflow.getId())

    ourProductWorkflow = ExternalMethod('temp', 'temp',
                                        productname+'.'+'cartmanager_workflow',
                                        'createcartmanager_workflow')
    workflow = ourProductWorkflow(self, 'cartmanager_workflow')
    if 'cartmanager_workflow' in workflowTool.listWorkflows():
        print >> out, 'cartmanager_workflow already in workflows.'
    else:
        workflowTool._setObject('cartmanager_workflow', workflow)
    workflowTool.setChainForPortalTypes(['CartManager'], workflow.getId())

    ##code-section after-workflow-install #fill in your manual code here
    ##/code-section after-workflow-install

    return workflowTool

def uninstallWorkflows(self, package, out):
    """Deinstall the workflows.

    This code doesn't really do anything, but you can place custom
    code here in the protected section.
    """

    ##code-section workflow-uninstall #fill in your manual code here
    ##/code-section workflow-uninstall

    pass
