# -*- coding: utf-8 -*-
#
# File: BaseAddressInformation.py
#
# Copyright (c) 2006 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallRegistry.IAddressInformation import IAddressInformation
from Products.PloneMallCustomer.config import *

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    StringField(
        name='address1',
        widget=StringWidget(
            label="Address 1",
            label_msgid='PloneMallCustomer_label_address1',
            i18n_domain='PloneMallCustomer',
        ),
        required=1
    ),

    StringField(
        name='address2',
        widget=StringWidget(
            label="Address 2",
            label_msgid='PloneMallCustomer_label_address2',
            i18n_domain='PloneMallCustomer',
        )
    ),

    StringField(
        name='postal_code',
        widget=StringWidget(
            label="Postal Code",
            label_msgid='PloneMallCustomer_label_postal_code',
            i18n_domain='PloneMallCustomer',
        ),
        required=1
    ),

    StringField(
        name='city',
        widget=StringWidget(
            label='City',
            label_msgid='PloneMallCustomer_label_city',
            i18n_domain='PloneMallCustomer',
        ),
        required=1
    ),

    StringField(
        name='state',
        widget=StringWidget(
            label='State',
            label_msgid='PloneMallCustomer_label_state',
            i18n_domain='PloneMallCustomer',
        ),
        required=0
    ),

    StringField(
        name='country',
        widget=StringWidget(
            label='Country',
            label_msgid='PloneMallCustomer_label_country',
            i18n_domain='PloneMallCustomer',
        ),
        required=1
    ),

    ComputedField(
        name='title',
        widget=ComputedField._properties['widget'](
            label='Title',
            label_msgid='PloneMallCustomer_label_title',
            i18n_domain='PloneMallCustomer',
        ),
        expression="context.getId()",
        accessor="Title"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BaseAddressInformation_schema = schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BaseAddressInformation(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IAddressInformation,)

    allowed_content_types = []
    _at_rename_after_creation = False

    schema = BaseAddressInformation_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    # Methods from Interface IAddressInformation

    security.declareProtected("View", 'getAddressInformationFields')
    def getAddressInformationFields(self):
        """
        <p>Return the AddressInformation achetypes fields list.</p>
        """

# end of class BaseAddressInformation

##code-section module-footer #fill in your manual code here
##/code-section module-footer



