# -*- coding: utf-8 -*-
#
# File: BaseCustomerInformation.py
#
# Copyright (c) 2006 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallRegistry.ICustomerInformation import ICustomerInformation
from Products.PloneMallRegistry.IAddressInformation import IAddressInformation
from Products.Archetypes.AllowedTypesByIface import AllowedTypesByIfaceMixin
from Products.PloneMallRegistry.IAddressInformation import IAddressInformation
from Products.PloneMallCustomer.config import *

##code-section module-header #fill in your manual code here
from Interface.Exceptions import BrokenMethodImplementation
import copy
##/code-section module-header

schema = Schema((

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BaseCustomerInformation_schema = schema.copy()

##code-section after-schema #fill in your manual code here
_marker=[]
##/code-section after-schema

class BaseCustomerInformation(AllowedTypesByIfaceMixin, BaseFolder):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(AllowedTypesByIfaceMixin,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),) + (ICustomerInformation,)

    allowed_content_types = []
    allowed_interfaces = [IAddressInformation] 
    _at_rename_after_creation = False

    schema = BaseCustomerInformation_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('initializeArchetype')
    def initializeArchetype(self,*a,**kw):
        """
        <p>creates a default addressInformation inside the customer</p>
        """
        self.getOrCreateAddress('default')

    # Methods from Interface ICustomerInformation

    security.declarePublic('getOrCreateAddress')
    def getOrCreateAddress(self,category):
        """
        returns the Address of the given category, if the address doesnt
        exist yet
        it creates one of the given type
        """
        if category not in self.objectIds():
            self.portal_mall_registry.constructContent(address_category_iface_map[category],self,category)
            addr=self.getAddress(category)
            if hasattr(addr.aq_base,'initializeAddress'):
                addr.initializeAddress(category)

        return self.getAddress(category)

    security.declarePublic('getAllAddresses')
    def getAllAddresses(self):
        """

        """

        return [o for o in self.contentValues() if IAddressInformation.isImplementedBy(o)]

    security.declarePublic('getAddress')
    def getAddress(self,category='default',default=_marker):
        """
        <p>returns the address information. if no address information
        for the given category is not present, it returns None.</p>
        <p>A default address is always present</p>
        """

        try:
            return self._getOb(category)
        except AttributeError:
            if default != _marker:
                return default
            else:
                raise

    security.declareProtected("View", 'getCustomerInformationFields')
    def getCustomerInformationFields(self):
        """
        <p>Return the CustomerInformation archetypes fields list.</p>
        """

        return self.Schema().fields()

    security.declarePublic('getFullName')
    def getFullName(self):
        """

        """
        raise BrokenMethodImplementation('getFullName','this Method must be implemented by the %s class' % self.__class__.__name__)

    security.declarePublic('setAddress')
    def setAddress(self,address,category='default'):
        """
        <p>assigns an address information to the customer.</p>
        """

        self._setObject(category,address)

    # Manually created methods

    def saveDefault(self):
        member=self.portal_membership.getAuthenticatedMember()
        if member:
            try:
                home=member.getHomeFolder()
                if not home:
                    self.portal_membership.createMemberArea(member.id)
                    ## for now we need it, but storing user defaults should be implemented
                    ## more elegantly
                    # lets not create member areas here - if they do not exist
                    # its because of site policy.
                    return
            except AttributeError:
                return

            if home:
                id=self.id+'_default'
                try:
                    home.manage_delObjects([id])
                except AttributeError:
                    pass #if its not there we cant delete it, so ignore it...
                except:
                    pass

                try:
                    #home.manage_clone(self,id)
                    cp=self.__class__(id)

                    home._setObject(id,cp)
                    cp.__dict__=copy.deepcopy(self.__dict__)
                except:
                    pass

                try:
                    self.portal_workflow.doActionFor(home[id],'hide')
                except:
                    pass

    def loadDefault(self):
        member=self.portal_membership.getAuthenticatedMember()
        if member:
            try:
                home=member.getHomeFolder()
            except AttributeError:
                return

            if home:
                old_id=self.id
                id=self.id+'_default'
                try:
                    orig=home[id]
                except KeyError:
                    return

                self.__dict__=copy.deepcopy(orig.__dict__)
                self.id=old_id


# end of class BaseCustomerInformation

##code-section module-footer #fill in your manual code here
##/code-section module-footer



