# -*- coding: utf-8 -*-
#
# File: CustomerInformation.py
#
# Copyright (c) 2006 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallCustomer.BaseCustomerInformation import BaseCustomerInformation
from Products.Archetypes.AllowedTypesByIface import AllowedTypesByIfaceMixin
from Products.PloneMallRegistry.IAddressInformation import IAddressInformation
from Products.PloneMallCustomer.config import *

##code-section module-header #fill in your manual code here
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema = Schema((

    StringField(
        name='firstname',
        widget=StringWidget(
            label="First Name",
            label_msgid='PloneMallCustomer_label_firstname',
            i18n_domain='PloneMallCustomer',
        ),
        required=1
    ),

    StringField(
        name='lastname',
        widget=StringWidget(
            label="Last Name",
            label_msgid='PloneMallCustomer_label_lastname',
            i18n_domain='PloneMallCustomer',
        ),
        required=1
    ),

    StringField(
        name='email',
        widget=StringWidget(
            label="Email",
            label_msgid='PloneMallCustomer_label_email',
            i18n_domain='PloneMallCustomer',
        ),
        required=1
    ),

    StringField(
        name='company',
        widget=StringWidget(
            label='Company',
            label_msgid='PloneMallCustomer_label_company',
            i18n_domain='PloneMallCustomer',
        )
    ),

    LinesField(
        name='phoneNumbers',
        widget=TextAreaWidget
        (
            label="Phone Numbers",
            label_msgid='PloneMallCustomer_label_phoneNumbers',
            i18n_domain='PloneMallCustomer',
        )
    ),

    StringField(
        name='EUVATId',
        widget=StringWidget(
            label="Vat ID",
            label_msgid='PloneMallCustomer_label_EUVATId',
            i18n_domain='PloneMallCustomer',
        )
    ),

    StringField(
        name='comment',
        widget=TextAreaWidget
        (
            label='Comment',
            label_msgid='PloneMallCustomer_label_comment',
            i18n_domain='PloneMallCustomer',
        )
    ),

    ComputedField(
        name='title',
        widget=ComputedField._properties['widget'](
            label='Title',
            label_msgid='PloneMallCustomer_label_title',
            i18n_domain='PloneMallCustomer',
        ),
        expression="context.getFirstname()+' '+context.getLastname()",
        accessor="Title"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

CustomerInformation_schema = BaseFolderSchema.copy() + \
    getattr(BaseCustomerInformation, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class CustomerInformation(AllowedTypesByIfaceMixin, BaseCustomerInformation):
    """Customer Information
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(AllowedTypesByIfaceMixin,'__implements__',()),) + (getattr(BaseCustomerInformation,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'CustomerInformation'

    meta_type = 'CustomerInformation'
    portal_type = 'CustomerInformation'
    allowed_content_types = [] + list(getattr(BaseCustomerInformation, 'allowed_content_types', []))
    allowed_interfaces = [] + getattr(BaseCustomerInformation, 'allowed_interfaces', [])
    filter_content_types = 1
    global_allow = 0
    #content_icon = 'CustomerInformation.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "CustomerInformation"
    typeDescMsgId = 'description_edit_customerinformation'

    _at_rename_after_creation = False

    schema = CustomerInformation_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getFullName')
    def getFullName(self):
        """

        """

        return '%s %s' % (self.getFirstname(),self.getLastname())

    # Manually created methods

    def getCustomer(self):
        ''''''

        return self



registerType(CustomerInformation, PROJECTNAME)
# end of class CustomerInformation

##code-section module-footer #fill in your manual code here
if register_customer_information:
    FactoryRegistry.registerMallFactory('CustomerInformation', CustomerInformation)
##/code-section module-footer



