# -*- coding: utf-8 -*-
#
# File: FullAddressInformation.py
#
# Copyright (c) 2006 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallCustomer.BaseAddressInformation import BaseAddressInformation
from Products.PloneMallRegistry.IFullAddressInformation import IFullAddressInformation
from Products.PloneMallCustomer.config import *

##code-section module-header #fill in your manual code here
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema = Schema((

    StringField(
        name='firstname',
        widget=StringWidget(
            label="First Name",
            label_msgid='PloneMallCustomer_label_firstname',
            i18n_domain='PloneMallCustomer',
        )
    ),

    StringField(
        name='lastname',
        widget=StringWidget(
            label="Last Name",
            label_msgid='PloneMallCustomer_label_lastname',
            i18n_domain='PloneMallCustomer',
        )
    ),

    StringField(
        name='company',
        widget=StringWidget(
            label='Company',
            label_msgid='PloneMallCustomer_label_company',
            i18n_domain='PloneMallCustomer',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

FullAddressInformation_schema = BaseSchema.copy() + \
    getattr(BaseAddressInformation, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
FullAddressInformation_schema.moveField('firstname', before='address1')
FullAddressInformation_schema.moveField('lastname', before='address1')
FullAddressInformation_schema.moveField('company', before='address1')

##/code-section after-schema

class FullAddressInformation(BaseAddressInformation):
    """Full Address Information
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseAddressInformation,'__implements__',()),) + (IFullAddressInformation,)

    # This name appears in the 'add' box
    archetype_name = 'FullAddressInformation'

    meta_type = 'FullAddressInformation'
    portal_type = 'FullAddressInformation'
    allowed_content_types = [] + list(getattr(BaseAddressInformation, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'FullAddressInformation.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "FullAddressInformation"
    typeDescMsgId = 'description_edit_fulladdressinformation'

    _at_rename_after_creation = False

    schema = FullAddressInformation_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods


registerType(FullAddressInformation, PROJECTNAME)
# end of class FullAddressInformation

##code-section module-footer #fill in your manual code here
if register_address_information:
   FactoryRegistry.registerMallFactory('FullAddressInformation', FullAddressInformation)
##/code-section module-footer



