from os.path import join

def adjustEncoding(str):
    return unicode(str, 'latin1').encode('utf-8')

class ISO3166Parser:

    def __init__(self):
        self._countries = []
        self._states = {}

    def parseCountries(self, countries):
        for c in open(countries).readlines()[3:]:
            t = [i.strip() for i in c.split(':')]
            t[1] = adjustEncoding(t[1])
            self._countries.append(tuple(t))
            
        self._countries.sort(lambda a,b:cmp(a[1],b[1]))

    def parseStates(self, country, states):
        sl = []
        for s in open(states).readlines()[3:]:
            l = [i.strip() for i in s.split(':')]
            t = (l[0].split('-')[1], adjustEncoding(l[1]))
            sl.append(t)
        self._states.update({country : sl})

    def parseAll(self, path):
        countries = join(path, 'countries.txt')
        self.parseCountries(countries)
        for cc in [c[0] for c in self._countries]:
            states = join(path, 'iso.%s.txt' % cc)
            self.parseStates(cc, states)

if __name__ == '__main__':
    p = ISO3166Parser()
    p.parseAll('iso3166')
