# -*- coding: utf-8 -*-
#
# File: Category.py
#
# Copyright (c) 2006 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallRegistry.ICategorizeable import ICategorizeable
from Products.PloneMallRegistry.ICategory import ICategory
from Products.PloneMallRegistry.IMallItem import IMallItem
from Products.Archetypes.AllowedTypesByIface import AllowedTypesByIfaceMixin
from Products.PloneMallRegistry.ICategorizeable import ICategorizeable
from Products.PloneMallItem.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.util import filterContents
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema = Schema((

    TextField(
        name='description',
        widget=TextAreaWidget(
            label="Short Description",
            label_msgid='PloneMallItem_label_description',
            i18n_domain='PloneMallItem',
        ),
        accessor="Desciption",
        searchable=1
    ),

    TextField(
        name='full_description',
        widget=TextAreaWidget(
            label="Full Description",
            label_msgid='PloneMallItem_label_full_description',
            i18n_domain='PloneMallItem',
        ),
        searchable=1
    ),

    ImageField(
        name='photo',
        widget=ImageWidget(
            label='Photo',
            label_msgid='PloneMallItem_label_photo',
            i18n_domain='PloneMallItem',
        ),
        storage=AttributeStorage(),
        sizes={'small':(80,80),'medium':(200,2000),'large':(600,600)}
    ),

    IntegerField(
        name='columns',
        default="2",
        widget=IntegerField._properties['widget'](
            label='Columns',
            label_msgid='PloneMallItem_label_columns',
            i18n_domain='PloneMallItem',
        ),
        schemata="PresentationOptions"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Category_schema = BaseFolderSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Category(AllowedTypesByIfaceMixin, BaseFolder):
    """Category
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(AllowedTypesByIfaceMixin,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),) + (ICategorizeable,) + (ICategory,)

    # This name appears in the 'add' box
    archetype_name = 'Category'

    meta_type = 'Category'
    portal_type = 'Category'
    allowed_content_types = ['Category']
    allowed_interfaces = [ICategorizeable] 
    filter_content_types = 1
    global_allow = 1
    #content_icon = 'Category.gif'
    immediate_view = 'category_view'
    default_view = 'category_view'
    suppl_views = ()
    typeDescription = "Category"
    typeDescMsgId = 'description_edit_category'

    _at_rename_after_creation = True

    schema = Category_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    # Methods from Interface ICategorizeable

    security.declareProtected("Modify portal content", 'removeFromCategory')
    def removeFromCategory(self,category):
        '''
        Remove the object from a category.
        '''

        self.deleteReference(category, "category")

    security.declareProtected("View", 'listCategories')
    def listCategories(self):
        '''
        List the categories where the object is registered.
        '''

        return self.getRefs("category")

    security.declareProtected("Modify portal content", 'addToCategory')
    def addToCategory(self,category):
        '''
        Add the object to a category.
        '''

        if not FactoryRegistry.objectSupportsInterface(category,ICategorizeable):
            raise TypeError("category %s is not registered as a ICategorizeable implementation" % \
                category.__class__.__name__)

        self.addReference(category, "category")

    # Methods from Interface ICategory

    security.declareProtected("View", 'getContents')
    def getContents(self, filter = {}):
        '''
        Return a list of objects that are registered inside the category. The
        result could be filtered using a dictionary, where the keys are object
        properties and the values are acceptable values for these keys.
        '''

        return filterContents(self.getBRefs('category') + [o for o in self.objectValues() if ICategorizeable.isImplementedBy(o)], filter)

    # Manually created methods

    def getShort_description(self):
        ''' for backward compatibility'''
        return self.Description()



registerType(Category, PROJECTNAME)
# end of class Category

##code-section module-footer #fill in your manual code here
if register_category:
   FactoryRegistry.registerMallFactory('Category', Category, (ICategory, ICategorizeable))
##/code-section module-footer



