# -*- coding: utf-8 -*-
#
# File: ItemVariant.py
#
# Copyright (c) 2006 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallItem.BaseItem import BaseItem
from Products.PloneMallItem.config import *

##code-section module-header #fill in your manual code here
from config import *
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.IMallItem import IMallItem
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema = Schema((

    LinesField(
        name='units',
        widget=LinesField._properties['widget'](
            label='Units',
            label_msgid='PloneMallItem_label_units',
            i18n_domain='PloneMallItem',
        ),
        required=1
    ),

    LinesField(
        name='values',
        widget=LinesField._properties['widget'](
            label='Values',
            label_msgid='PloneMallItem_label_values',
            i18n_domain='PloneMallItem',
        ),
        required=1
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

ItemVariant_schema = BaseSchema.copy() + \
    getattr(BaseItem, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class ItemVariant(BaseContent, BaseItem):
    """Item Variant
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(BaseItem,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'ItemVariant'

    meta_type = 'ItemVariant'
    portal_type = 'ItemVariant'
    allowed_content_types = [] + list(getattr(BaseItem, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'ItemVariant.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "ItemVariant"
    typeDescMsgId = 'description_edit_itemvariant'


    actions =  (


       {'action': "string:${object_url}/itemvariant_view",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = ItemVariant_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    # Manually created methods

    def getShort_description(self):
        '''
        Return the short description. This method is just an alias to
        the same method in the AdvancedItem class. It is important
        only to avoid problems on UI and make things easier.
        '''

        return self.aq_parent.getShort_description()



registerType(ItemVariant, PROJECTNAME)
# end of class ItemVariant

##code-section module-footer #fill in your manual code here
if register_advanced_item:
   FactoryRegistry.registerMallFactory('ItemVariant', ItemVariant, (IMallItem,))
##/code-section module-footer



