from StringIO import StringIO
from App.Common import package_home
from Products.PloneMallOrder.config import product_globals as GLOBALS
from Products.CMFCore.utils import getToolByName
import os.path

def installIOrderICartRelations(portal, out):
    """ Override the relations settings from the model. We
    need to make all objects implementing IOrder able to link
    to ICarts, not only the Order type. It is not possible in agx to specify
    a relation between two interfaces. 
    """
    relations_tool = getToolByName(portal,'relations_library')
    
    xmlpath = os.path.join(package_home(GLOBALS),'Extensions/relations_iorder_icart.xml')
    f = open(xmlpath)
    xml = f.read()
    f.close()
    relations_tool.importXML(xml)
    print >> out, 'Installed relations policy for IOrder and ICart.'


def install(portal):
    out=StringIO()
    
    if portal.portal_quickinstaller.isProductInstalled('PloneSelenium'):
        action = {'id':'plonemall_order',
                  'name':'plonemall_order',
                  'action':'string:here/get_plonemall_order_ftests',
                  'condition': '',
                  'permission': 'View',
                  'category':'ftests',
                  'visible': 1}
        
        portal.portal_selenium.addAction(**action)
        print >> out, 'Selenium test added'
    else:
        print >> out, 'No Selenium tests added since PloneSelenium isnt installed (not critical)'

    installIOrderICartRelations(portal, out)
        
    return out