# -*- coding: utf-8 -*-
#
# File: PloneMallOrder.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'


from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.PloneMallOrder.config import *

##code-section create-workflow-module-header #fill in your manual code here
##/code-section create-workflow-module-header


productname = 'PloneMallOrder'

def setuporder_item_workflow(self, workflow):
    """Define the order_item_workflow workflow.
    """

    workflow.setProperties(title='order_item_workflow')

    ##code-section create-workflow-setup-method-header #fill in your manual code here
    ##/code-section create-workflow-setup-method-header


    for s in ['finished', 'cancelled', 'failed', 'created']:
        workflow.states.addState(s)

    for t in ['cancel', 'finish', 'Im7c7cdb8bm1088aaba85fmm6612']:
        workflow.transitions.addTransition(t)

    for v in ['review_history', 'comments', 'time', 'actor', 'action']:
        workflow.variables.addVariable(v)

    workflow.addManagedPermission('Modify portal content')
    workflow.addManagedPermission('Add portal content')
    workflow.addManagedPermission('Access contents information')
    workflow.addManagedPermission('View')

    for l in []:
        if not l in workflow.worklists.objectValues():
            workflow.worklists.addWorklist(l)

    ## Initial State

    workflow.states.setInitialState('created')

    ## States initialization

    stateDef = workflow.states['finished']
    stateDef.setProperties(title="""finished""",
                           description="""""",
                           transitions=[])

    stateDef = workflow.states['cancelled']
    stateDef.setProperties(title="""cancelled""",
                           description="""""",
                           transitions=[])

    stateDef = workflow.states['failed']
    stateDef.setProperties(title="""failed""",
                           description="""""",
                           transitions=[])

    stateDef = workflow.states['created']
    stateDef.setProperties(title="""created""",
                           description="""""",
                           transitions=['finish', 'cancel', 'Im7c7cdb8bm1088aaba85fmm6612'])
    stateDef.setPermission('Modify portal content',
                           1,
                           [])
    stateDef.setPermission('Add portal content',
                           1,
                           [])
    stateDef.setPermission('Access contents information',
                           1,
                           [])
    stateDef.setPermission('View',
                           1,
                           [])

    ## Transitions initialization

    ## Creation of workflow scripts
    for wf_scriptname in ['cancel']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.order_item_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['cancel']
    transitionDef.setProperties(title="""cancel""",
                                new_state_id="""cancelled""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""cancel""",
                                actbox_name="""cancel""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['finish']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.order_item_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['finish']
    transitionDef.setProperties(title="""finish""",
                                new_state_id="""finished""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""finish""",
                                actbox_name="""finish""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['fail']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.order_item_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['Im7c7cdb8bm1088aaba85fmm6612']
    transitionDef.setProperties(title="""Im7c7cdb8bm1088aaba85fmm6612""",
                                new_state_id="""failed""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""fail""",
                                actbox_name="""Im7c7cdb8bm1088aaba85fmm6612""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## State Variable
    workflow.variables.setStateVar('review_state')

    ## Variables initialization
    variableDef = workflow.variables['review_history']
    variableDef.setProperties(description="""Provides access to workflow history""",
                              default_value="""""",
                              default_expr="""state_change/getHistory""",
                              for_catalog=0,
                              for_status=0,
                              update_always=0,
                              props={'guard_permissions': 'Request review; Review portal content'})

    variableDef = workflow.variables['comments']
    variableDef.setProperties(description="""Comments about the last transition""",
                              default_value="""""",
                              default_expr="""python:state_change.kwargs.get('comment', '')""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['time']
    variableDef.setProperties(description="""Time of the last transition""",
                              default_value="""""",
                              default_expr="""state_change/getDateTime""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['actor']
    variableDef.setProperties(description="""The ID of the user who performed the last transition""",
                              default_value="""""",
                              default_expr="""user/getId""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['action']
    variableDef.setProperties(description="""The last transition""",
                              default_value="""""",
                              default_expr="""transition/getId|nothing""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    ## Worklists Initialization


    # WARNING: below protected section is deprecated.
    # Add a tagged value 'worklist' with the worklist name to your state(s) instead.

    ##code-section create-workflow-setup-method-footer #fill in your manual code here
    ##/code-section create-workflow-setup-method-footer



def createorder_item_workflow(self, id):
    """Create the workflow for PloneMallOrder.
    """

    ob = DCWorkflowDefinition(id)
    setuporder_item_workflow(self, ob)
    return ob

addWorkflowFactory(createorder_item_workflow,
                   id='order_item_workflow',
                   title='order_item_workflow')

##code-section create-workflow-module-footer #fill in your manual code here
##/code-section create-workflow-module-footer

