# -*- coding: utf-8 -*-
#
# File: PloneMallOrder.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'


from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.PloneMallOrder.config import *

##code-section create-workflow-module-header #fill in your manual code here
##/code-section create-workflow-module-header


productname = 'PloneMallOrder'

def setupordermanager_workflow(self, workflow):
    """Define the ordermanager_workflow workflow.
    """

    workflow.setProperties(title='ordermanager_workflow')

    ##code-section create-workflow-setup-method-header #fill in your manual code here
    ##/code-section create-workflow-setup-method-header


    for s in ['active_members_only', 'closed', 'active_anonymous']:
        workflow.states.addState(s)

    for t in ['close', 'activate_for_members', 'activate_for_anonymous']:
        workflow.transitions.addTransition(t)

    for v in ['review_history', 'comments', 'time', 'actor', 'action']:
        workflow.variables.addVariable(v)

    workflow.addManagedPermission('Add Order Content')
    workflow.addManagedPermission('Add portal content')
    workflow.addManagedPermission('Buy item')
    workflow.addManagedPermission('View')
    workflow.addManagedPermission('Access contents information')

    for l in []:
        if not l in workflow.worklists.objectValues():
            workflow.worklists.addWorklist(l)

    ## Initial State

    workflow.states.setInitialState('active_anonymous')

    ## States initialization

    stateDef = workflow.states['active_members_only']
    stateDef.setProperties(title="""active_members_only""",
                           description="""""",
                           transitions=['activate_for_anonymous', 'close'])
    stateDef.setPermission('Add Order Content',
                           0,
                           ['Manager', 'Owner', 'Member'])
    stateDef.setPermission('Add portal content',
                           0,
                           ['Manager', 'Owner', 'Member'])
    stateDef.setPermission('Buy item',
                           0,
                           ['Manager', 'Owner', 'Member'])
    stateDef.setPermission('View',
                           0,
                           ['Manager'])
    stateDef.setPermission('Access contents information',
                           0,
                           ['Anonymous', 'Authenticated'])

    stateDef = workflow.states['closed']
    stateDef.setProperties(title="""closed""",
                           description="""""",
                           transitions=['activate_for_anonymous', 'activate_for_members'])
    stateDef.setPermission('Add Order Content',
                           0,
                           ['Manager'])

    stateDef = workflow.states['active_anonymous']
    stateDef.setProperties(title="""active_anonymous""",
                           description="""""",
                           transitions=['close', 'activate_for_members'])
    stateDef.setPermission('Add Order Content',
                           0,
                           ['Anonymous', 'Authenticated'])
    stateDef.setPermission('Add portal content',
                           0,
                           ['Anonymous', 'Authenticated'])
    stateDef.setPermission('Buy item',
                           0,
                           ['Anonymous', 'Authenticated'])
    stateDef.setPermission('View',
                           0,
                           ['Manager'])
    stateDef.setPermission('Access contents information',
                           0,
                           ['Anonymous', 'Authenticated'])

    ## Transitions initialization

    transitionDef = workflow.transitions['close']
    transitionDef.setProperties(title="""close""",
                                new_state_id="""closed""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""close""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['activate_for_members']
    transitionDef.setProperties(title="""activate_for_members""",
                                new_state_id="""active_members_only""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""activate_for_members""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['activate_for_anonymous']
    transitionDef.setProperties(title="""activate_for_anonymous""",
                                new_state_id="""active_anonymous""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""activate_for_anonymous""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## State Variable
    workflow.variables.setStateVar('review_state')

    ## Variables initialization
    variableDef = workflow.variables['review_history']
    variableDef.setProperties(description="""Provides access to workflow history""",
                              default_value="""""",
                              default_expr="""state_change/getHistory""",
                              for_catalog=0,
                              for_status=0,
                              update_always=0,
                              props={'guard_permissions': 'Request review; Review portal content'})

    variableDef = workflow.variables['comments']
    variableDef.setProperties(description="""Comments about the last transition""",
                              default_value="""""",
                              default_expr="""python:state_change.kwargs.get('comment', '')""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['time']
    variableDef.setProperties(description="""Time of the last transition""",
                              default_value="""""",
                              default_expr="""state_change/getDateTime""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['actor']
    variableDef.setProperties(description="""The ID of the user who performed the last transition""",
                              default_value="""""",
                              default_expr="""user/getId""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['action']
    variableDef.setProperties(description="""The last transition""",
                              default_value="""""",
                              default_expr="""transition/getId|nothing""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    ## Worklists Initialization


    # WARNING: below protected section is deprecated.
    # Add a tagged value 'worklist' with the worklist name to your state(s) instead.

    ##code-section create-workflow-setup-method-footer #fill in your manual code here
    ##/code-section create-workflow-setup-method-footer



def createordermanager_workflow(self, id):
    """Create the workflow for PloneMallOrder.
    """

    ob = DCWorkflowDefinition(id)
    setupordermanager_workflow(self, ob)
    return ob

addWorkflowFactory(createordermanager_workflow,
                   id='ordermanager_workflow',
                   title='ordermanager_workflow')

##code-section create-workflow-module-footer #fill in your manual code here
##/code-section create-workflow-module-footer

