# -*- coding: utf-8 -*-
#
# File: Order.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallRegistry.IOrder import IOrder
from Products.PloneMallRegistry.ICustomerInformation import ICustomerInformation
from Products.Archetypes.AllowedTypesByIface import AllowedTypesByIfaceMixin
from Products.PloneMallRegistry.ICustomerInformation import ICustomerInformation
from Products.PloneMallRegistry.IPaymentInformation import IPaymentInformation
from Products.PloneMallRegistry.ICart import ICart
from Products.Relations.field import RelationField
from Products.PloneMallOrder.config import *

##code-section module-header #fill in your manual code here
from types import StringTypes
##/code-section module-header

schema = Schema((

    RelationField(
        name='cart_object',
        widget=ReferenceWidget(
            label='Cart_object',
            label_msgid='PloneMallOrder_label_cart_object',
            i18n_domain='PloneMallOrder',
        ),
        multiValued=0,
        relationship='order_cart_object'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Order_schema = BaseFolderSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
from Products.CMFCore.utils import getToolByName
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry

##/code-section after-schema

class Order(AllowedTypesByIfaceMixin, BaseFolder):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(AllowedTypesByIfaceMixin,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),) + (IOrder,)

    # This name appears in the 'add' box
    archetype_name = 'Order'

    meta_type = 'Order'
    portal_type = 'Order'
    allowed_content_types = []
    allowed_interfaces = [ICustomerInformation,IPaymentInformation,ICart] 
    filter_content_types = 1
    global_allow = 0
    #content_icon = 'Order.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Order"
    typeDescMsgId = 'description_edit_order'

    _at_rename_after_creation = False

    schema = Order_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getOrCreateCustomerInformation')
    def getOrCreateCustomerInformation(self):
        """

        """

        mall_factory=getToolByName(self,'portal_mall_registry')
        mall_factory.constructContent(ICustomerInformation,self,'customer')
        return self.customer

    security.declarePublic('initiateOrderProcess')
    def initiateOrderProcess(self):
        """
        initiates the order, so that it is ready for filling in the user
        options
        """

        self.getOrCreateCustomerInformation()
        self.setCart(self.portal_cartmanager.getOrCreateCart())
        self.portal_workflow.doActionFor(self,'start')

    security.declarePublic('getNextStep')
    def getNextStep(self, url=None):
        """
        calculates the next step in the order process.
        this function is called by the form controller
        scripts to determine the next redirect
        """

        #first check if the current url matches to one of the urls in the plan
        if not url:
            url=self.REQUEST.URL

        currentstep=None
        plan=list(self.getOrder().getPlan())

        #Substeps are used to map more than one url to a step.
        for step in plan:
            substeps=step.split(',')
            for substep in substeps:
                if url.endswith(substep):
                    currentstep=step
                    break
            if currentstep:
                break

        if currentstep:
            ind=plan.index(currentstep)
            try:
                return plan[ind+1].split(',')[0]
            except IndexError:
                return None

        return plan[0].split(',')[0]

    # Methods from Interface IOrder

    security.declareProtected("View", 'getShippingAddress')
    def getShippingAddress(self):
        """
        <p>Return the general shipping address.</p>
        """

    security.declareProtected("View", 'hasTax')
    def hasTax(self):
        """
        <p>Return true if the order has tax. Nowdays, It's a bit hard to
        find a business model that does not need to pay taxes, but a
        good example where payment information is useless are bookstores
        (that does not pay taxes because books are cultural stuff).</p>
        """

    security.declareProtected("Modify portal content", 'setShippingAddressByItem')
    def setShippingAddressByItem(self,item,shipping_address):
        """
        <p>Set the shipping address for the cart item.</p>
        """

    security.declareProtected("Modify portal content", 'setTaxByItem')
    def setTaxByItem(self,item,tax):
        """
        <p>Set the tax for the cart item.</p>
        """

    security.declareProtected("View", 'getShippingAddressByItem')
    def getShippingAddressByItem(self,item):
        """
        <p>Return the shipping address for the cart item.</p>
        """

    security.declareProtected("Modify portal content", 'setPaymentAddress')
    def setPaymentAddress(self,payment_address):
        """
        <p>Set the payment address.</p>
        """

    security.declareProtected("View", 'getPaymentAddress')
    def getPaymentAddress(self):
        """
        <p>Return the payment address.</p>
        """

    security.declareProtected("View", 'getTaxByItem')
    def getTaxByItem(self,item):
        """
        <p>Return the tax for the cart item.</p>
        """

    security.declareProtected("View", 'getCart')
    def getCart(self):
        """
        <p>Return the order cart.</p>
        """

        return self.getCart_object()

    security.declareProtected("Modify portal content", 'setCart')
    def setCart(self,cart):
        """
        <p>Set the order cart. Here, a good approach is move the cart
        from the CartManager to inside the Order. It would avoid
        possible problems with session ids conflicts and will turn the
        persistence model more elegant. It's not mandatory, duo the
        placeless design of the interface, but It's a good practice:
        keep everything about an Order inside itself.</p>
        """
        self.setCart_object(cart)
        #and take the ownership
        member=self.portal_membership.getAuthenticatedMember()
        if member:
            try:
                om=self.portal_ordermanager
                user=member.getUser()
                try:
                    om.changeOwnershipOf(cart,user,True)
                except AttributeError,e:
                    # we catch this error because it happens in conjunction with
                    # PluggableAuthService userfolders and GRUF
                    if str(e) == 'startswith':
                        om.changeOwnershipOf(cart,str(user),True)
                    else:
                        raise

                #cart.changeOwnership(member.getUser(),True)
            except TypeError:
                pass

    security.declareProtected("Modify portal content", 'setPayment')
    def setPayment(self, payment):
        """
        <p>Set the payment.</p>
        """
        # The payment information instance is already added to the order by PloneMallPayment/utils.py
    security.declareProtected("Modify portal content", 'setShippingAddress')
    def setShippingAddress(self, shipping_address):
        """
        <p>Set the general shipping address.</p>
        """

    security.declarePublic('getNetTotal')
    def getNetTotal(self):
        """
        returns the order's total without tax, shipping etc.
        """

        total=self.getCart().getTotal()
        return total

    security.declareProtected("View", 'getTotal')
    def getTotal(self):
        """
        <p>Return the order total.</p>
        """

        total=self.getNetTotal()

        if self.hasShipping():
            total+=self.getShipping().getShippingTotal()

        return total

    security.declareProtected("Modify portal content", 'setCustomer')
    def setCustomer(self, customer):
        """
        <p>Set the customer.</p>
        """

        self._setObject('customer', customer)

    security.declareProtected("View", 'getTax')
    def getTax(self):
        """
        <p>Return the tax.</p>
        """

    security.declareProtected("View", 'getCustomerAddress')
    def getCustomerAddress(self):
        """
        <p>Return the customer address.</p>
        """

    security.declareProtected("View", 'hasShippingAddressByItem')
    def hasShippingAddressByItem(self):
        """
        <p>Return true if the order has different shipping addresses for
        each cart item.</p>
        """

    security.declareProtected("Modify portal content", 'setShipping')
    def setShipping(self, shipping):
        """
        <p>Set the shipping.</p>
        """

        self._setObject('shipping_information',shipping)

    security.declareProtected("View", 'hasShipping')
    def hasShipping(self):
        """
        <p>Return true if the order has shipping. In some business
        models, shipping information is useless (e.g. a service provider
        that sell hosting plan or a theater that sells tickets).</p>
        """

        return 'shipping_information' in self.objectIds()

    security.declareProtected("View", 'hasPayment')
    def hasPayment(self):
        """
        <p>Return true if the order has payment. Could appears strange,
        but in some business models, payment information would be
        useless (e.g. a theater that does tickets reservations instead
        of really sell it by internet; you pay when you get the ticket
        at the movies)</p>
        """
        pass

    security.declareProtected("View", 'hasTaxByItem')
    def hasTaxByItem(self):
        """
        <p>Return true if the order has different taxes for each cart
        item.</p>
        """
        pass

    security.declareProtected("Modify portal content", 'setTax')
    def setTax(self, tax):
        """
        <p>Set the tax.</p>
        """
        pass

    security.declareProtected("View", 'getPayment')
    def getPayment(self):
        """
        <p>Return the payment.</p>
        """
        return self.payment_information

    security.declareProtected("View", 'getShipping')
    def getShipping(self):
        """
        <p>Return the shipping.</p>
        """

        return self.shipping_information

    security.declareProtected("Modify portal content", 'setCustomerAddress')
    def setCustomerAddress(self, customer_address):
        """
        <p>Set the customer address.</p>
        """

    security.declareProtected("View", 'getCustomer')
    def getCustomer(self):
        """
        <p>Return the customer.</p>
        """

        return self._getOb('customer')

    # Manually created methods

    def sendOrderConfirmation(self):
        om=self.aq_parent
        for mailer in om.getMailers():
            mailer.sendOrderConfirmation(self)

    def notifyChanged(self, object):
        ''' called if subprocess changed its state '''
        pass
    def getOrder(self):
        return self

    def getOrderNumber(self):
        return self.getId()

    def initiatePayment(self, payment_settings):
        ''' '''
        # process the payment method
        if type(payment_settings) in StringTypes:
            payment_settings=self.portal_paymentsettings[payment_settings]

        # Payment Method (pm)
        pmf = FactoryRegistry.getMallFactory(payment_settings.getPaymentMethodName())
        pm = pmf()
        pm.processPayment(self, payment_settings)
        #self.getPayment().setOrder(self)


registerType(Order, PROJECTNAME)
# end of class Order

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('Order', Order)
##/code-section module-footer



