# -*- coding: utf-8 -*-
#
# File: OrderManager.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallRegistry.IOrderManager import IOrderManager
from Products.PloneMallOrder.Order import Order
from Products.PloneMallRegistry.IOrder import IOrder
from Products.Archetypes.AllowedTypesByIface import AllowedTypesByIfaceMixin
from Products.PloneMallRegistry.IOrder import IOrder
from Products.Relations.field import RelationField
from Products.PloneMallOrder.config import *


from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
from AccessControl import getSecurityManager

default_plan=[
    'customer/enterCustomerData,customer/customer_edit',
    'calculateShipping',
    'confirmOrder',
    'payment_select,afterCheckout',
    '../order_thankyou']

##/code-section module-header

schema = Schema((

    IntegerField(
        name='current_order_id',
        default="0",
        widget=IntegerField._properties['widget'](
            label='Current_order_id',
            label_msgid='PloneMallOrder_label_current_order_id',
            i18n_domain='PloneMallOrder',
        )
    ),

    LinesField(
        name='plan',
        default=default_plan,
        widget=LinesField._properties['widget'](
            label='Plan',
            label_msgid='PloneMallOrder_label_plan',
            i18n_domain='PloneMallOrder',
        )
    ),

    RelationField(
        name='mailers',
        widget=ReferenceWidget(
            label='Mailers',
            label_msgid='PloneMallOrder_label_mailers',
            i18n_domain='PloneMallOrder',
        ),
        multiValued=1,
        relationship='ordermanager_mailers'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

OrderManager_schema = BaseBTreeFolderSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class OrderManager(UniqueObject, AllowedTypesByIfaceMixin, BaseBTreeFolder):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(AllowedTypesByIfaceMixin,'__implements__',()),) + (getattr(BaseBTreeFolder,'__implements__',()),) + (IOrderManager,)

    # This name appears in the 'add' box
    archetype_name = 'OrderManager'

    meta_type = 'OrderManager'
    portal_type = 'OrderManager'
    allowed_content_types = []
    allowed_interfaces = [IOrder] 
    filter_content_types = 1
    global_allow = 0
    #content_icon = 'OrderManager.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "OrderManager"
    typeDescMsgId = 'description_edit_ordermanager'
    #toolicon = 'OrderManager.gif'

    _at_rename_after_creation = False

    schema = OrderManager_schema

    ##code-section class-header #fill in your manual code here
    security.declarePublic('Creator')
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseBTreeFolder.__init__(self,'portal_ordermanager')
        self.setTitle('OrderManager')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer


    # tool should not appear in portal_catalog
    def at_post_edit_script(self):
        self.unindexObject()
        
        ##code-section post-edit-method-footer #fill in your manual code here
        ##/code-section post-edit-method-footer


    # Methods

    security.declarePublic('getNextOrderId')
    def getNextOrderId(self):
        """

        """

        #TODO: getNextOrderId should use UIDs or other non-guessable numbers
        currid=int(self.getCurrent_order_id())
        nextid=int(currid) + 1
        self.setCurrent_order_id(nextid)
        self.last_order_id=currid
        return nextid

    # Methods from Interface IOrderManager

    security.declareProtected("View", 'getOrderById')
    def getOrderById(self,order_id):
        """
        <p>Return the order by its number.</p>
        """


        return self._getOb(str(order_id), None)

    security.declareProtected("Buy item", 'getOrCreateOrder')
    def getOrCreateOrder(self):
        """

        """
        cartmanager=self.portal_cartmanager
        cart=cartmanager.getOrCreateCart()
        order=cart.getOrder()
        if not order:
            oid=self.addOrder()
            order=self.getOrderById(oid)
            order.initiateOrderProcess()

        return order

    security.declareProtected("Buy item", 'addOrder')
    def addOrder(self):
        """
        <p>Add a new Order and returns the Order id.</p>
        """

        # create Order (o)
        order_id=self.getNextOrderId()
        ##o = Order(str(order_id))
        ##self._setObject(str(order_id), o)
        ##o = getattr(self, str(order_id))
        # Create order by interface. The first registered class for IOrder is used.
        mall_factory=getToolByName(self, 'portal_mall_registry')
        mall_factory.constructContent(IOrder, self, str(order_id))
        return order_id

    # Manually created methods

    def changeOwnershipOf(self, object, owner, recursive=0):
        """Changes the ownership of an object."""
        membership = getToolByName(self, 'portal_membership')
        acl_users = getattr(self, 'acl_users')
        user = acl_users.getUserById(owner)
        if user is not None:
            user = user.__of__(acl_users)
        else:
            user = getSecurityManager().getUser()

        catalog_tool = getToolByName(self, 'portal_catalog')
        object.changeOwnership(user, recursive)

        def fixOwnerRole(object, user_id):
            # Get rid of all other owners
            owners = object.users_with_local_role('Owner')
            for o in owners:
                roles = list(object.get_local_roles_for_userid(o))
                roles.remove('Owner')
                if roles:
                    object.manage_setLocalRoles(o, roles)
                else:
                    object.manage_delLocalRoles([o])
            # Fix for 1750
            roles = list(object.get_local_roles_for_userid(user_id))
            roles.append('Owner')
            object.manage_setLocalRoles(user_id, roles)

        fixOwnerRole(object, user.getId())
        catalog_tool.reindexObject(object)

        if recursive:
            purl = getToolByName(self, 'portal_url')
            _path = purl.getRelativeContentURL(object)
            subobjects = [b.getObject() for b in \
                         catalog_tool(path={'query':_path,'level':1})]
            for obj in subobjects:
                fixOwnerRole(obj, user.getId())
                catalog_tool.reindexObject(obj)

    def view(self,*a,**kw):
        '''circumvent plone bug that view doesnt redirect to the correct view method'''
        return self.base_view(*a,**kw)



registerType(OrderManager, PROJECTNAME)
# end of class OrderManager

##code-section module-footer #fill in your manual code here
##/code-section module-footer



