## Script (Python) "get_plone_workflow_ftests"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##

# The following users have to exist:
#
#  sampleadmin          Manager
#  samplemember         Member
#  sampleowner          Member, Owner
#  samplereviewer       Member, Reviewer

selenium = context.portal_selenium
suite = selenium.getSuite()
suite.setTargetLanguage('en')
portal=context.portal_url.getPortalObject()
portal.portal_mall_registry.setDefaultCurrency('EUR')

selenium.addUser(id = 'sampleadmin',fullname='Sample Admin',roles=['Member', 'Manager',])
selenium.addUser(id = 'samplemember',fullname='Sample Member',roles=['Member',])
selenium.addUser(id = 'sampleowner',fullname='Sample Owner',roles=['Member', 'Owner',])
selenium.addUser(id = 'samplereviewer',fullname='Sample Reviewer',roles=['Member', 'Reviewer',])

TestLogout = suite.TestLogout
TestLoginPortlet  = suite.TestLoginPortlet
TestSwitchToLanguage = suite.TestSwitchToLanguage

if not hasattr(portal,'ta1'):
    portal.invokeFactory('SimpleItem','ta1')
    portal.ta1.update(title='Tachyonenbeschleuniger',price='13.1',sku_code='ta1')

def TestAddToCart():
    t = suite.getTest()
    t.open("/ta1")
    t.clickAndWait("//input[contains(@id,'plonemall_add_to_cart')]")
    t.clickAndWait("//input[@id='plonemall_cart_view_checkout']")
    return t

def TestFillInCustomer():
    t=suite.getTest()
    t.type("//input[contains(@name,'firstname')]","Donald")   
    t.type("//input[contains(@name,'lastname')]","Duck")   
    t.type("//input[contains(@name,'email')]","donald@duck.com")   
    t.type("//input[contains(@name,'company')]","Duck Enterprises")
#    t.type("//input[contains(@name,'Numbers')]","3242424")   
    t.type("//input[contains(@name,'address1')]","Duck Road 13")   
    t.type("//input[contains(@name,'city')]","Duckburg")   
    t.type("//input[contains(@name,'postal')]","1313")

    t.type("//input[contains(@name,'state')]","Calisota")
    t.type("//input[contains(@name,'country')]","USA")   
    t.clickAndWait("//input[@name='form_submit']")

   

    
    

   
    return t
    
suite.addTests('PloneMall Order',
          'Put Item into the Shopping Cart',
          TestLogout(),
          TestSwitchToLanguage('en'),
          TestLoginPortlet('sampleadmin'),
          TestAddToCart(),
          TestFillInCustomer(),
         )

return suite
