# -*- coding: utf-8 -*-
#
# File: PloneMallPayment.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'


from Products.CMFCore.utils import getToolByName
from Products.ExternalMethod.ExternalMethod import ExternalMethod

##code-section module-header #fill in your manual code here
##/code-section module-header

def installWorkflows(self, package, out):
    """Install the custom workflows for this product."""

    productname = 'PloneMallPayment'
    workflowTool = getToolByName(self, 'portal_workflow')

    ourProductWorkflow = ExternalMethod('temp', 'temp',
                                        productname+'.'+'plonemall_payment_workflow',
                                        'createplonemall_payment_workflow')
    workflow = ourProductWorkflow(self, 'plonemall_payment_workflow')
    if 'plonemall_payment_workflow' in workflowTool.listWorkflows():
        print >> out, 'plonemall_payment_workflow already in workflows.'
    else:
        workflowTool._setObject('plonemall_payment_workflow', workflow)
    workflowTool.setChainForPortalTypes(['PaymentInformation'], workflow.getId())

    ourProductWorkflow = ExternalMethod('temp', 'temp',
                                        productname+'.'+'plonemall_redirecting_payment_workflow',
                                        'createplonemall_redirecting_payment_workflow')
    workflow = ourProductWorkflow(self, 'plonemall_redirecting_payment_workflow')
    if 'plonemall_redirecting_payment_workflow' in workflowTool.listWorkflows():
        print >> out, 'plonemall_redirecting_payment_workflow already in workflows.'
    else:
        workflowTool._setObject('plonemall_redirecting_payment_workflow', workflow)
    workflowTool.setChainForPortalTypes(['RedirectingPaymentInformation', 'QentaPaymentInformation', 'PayPalPaymentInformation'], workflow.getId())

    ##code-section after-workflow-install #fill in your manual code here
    ##/code-section after-workflow-install

    return workflowTool

def uninstallWorkflows(self, package, out):
    """Deinstall the workflows.

    This code doesn't really do anything, but you can place custom
    code here in the protected section.
    """

    ##code-section workflow-uninstall #fill in your manual code here
    ##/code-section workflow-uninstall

    pass
