# -*- coding: utf-8 -*-
#
# File: PloneMallPayment.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'


from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.PloneMallPayment.config import *

##code-section create-workflow-module-header #fill in your manual code here
##/code-section create-workflow-module-header


productname = 'PloneMallPayment'

def setupplonemall_payment_workflow(self, workflow):
    """Define the plonemall_payment_workflow workflow.
    """

    workflow.setProperties(title='plonemall_payment_workflow')

    ##code-section create-workflow-setup-method-header #fill in your manual code here
    ##/code-section create-workflow-setup-method-header


    for s in ['uninitialized', 'initialized', 'validation', 'validated', 'processing', 'sucessful', 'failure', 'aborted']:
        workflow.states.addState(s)

    for t in ['doProcessing', 'abort', 'startProcessing', 'initialize', 'retryProcessing', 'validate', 'validationFail', 'processFail', 'validationSucceed']:
        workflow.transitions.addTransition(t)

    for v in ['review_history', 'comments', 'time', 'actor', 'action']:
        workflow.variables.addVariable(v)


    for l in []:
        if not l in workflow.worklists.objectValues():
            workflow.worklists.addWorklist(l)

    ## Initial State

    workflow.states.setInitialState('uninitialized')

    ## States initialization

    stateDef = workflow.states['uninitialized']
    stateDef.setProperties(title="""uninitialized""",
                           description="""""",
                           transitions=['initialize', 'abort'])

    stateDef = workflow.states['initialized']
    stateDef.setProperties(title="""initialized""",
                           description="""""",
                           transitions=['validate', 'abort'])

    stateDef = workflow.states['validation']
    stateDef.setProperties(title="""validation""",
                           description="""""",
                           transitions=['validationFail', 'validationSucceed'])

    stateDef = workflow.states['validated']
    stateDef.setProperties(title="""validated""",
                           description="""""",
                           transitions=['startProcessing'])

    stateDef = workflow.states['processing']
    stateDef.setProperties(title="""processing""",
                           description="""""",
                           transitions=['doProcessing', 'processFail'])

    stateDef = workflow.states['sucessful']
    stateDef.setProperties(title="""sucessful""",
                           description="""""",
                           transitions=[])

    stateDef = workflow.states['failure']
    stateDef.setProperties(title="""failure""",
                           description="""""",
                           transitions=['retryProcessing'])

    stateDef = workflow.states['aborted']
    stateDef.setProperties(title="""aborted""",
                           description="""""",
                           transitions=[])

    ## Transitions initialization

    transitionDef = workflow.transitions['doProcessing']
    transitionDef.setProperties(title="""doProcessing""",
                                new_state_id="""sucessful""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""doProcessing""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['abort']
    transitionDef.setProperties(title="""abort""",
                                new_state_id="""aborted""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""abort""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['startProcessing']
    transitionDef.setProperties(title="""startProcessing""",
                                new_state_id="""processing""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""startProcessing""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['initialize']
    transitionDef.setProperties(title="""initialize""",
                                new_state_id="""initialized""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""initialize""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['retryProcessing']
    transitionDef.setProperties(title="""retryProcessing""",
                                new_state_id="""uninitialized""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""retryProcessing""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['validate']
    transitionDef.setProperties(title="""validate""",
                                new_state_id="""validation""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""validate""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['validationFail']
    transitionDef.setProperties(title="""validationFail""",
                                new_state_id="""failure""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""validationFail""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['processFail']
    transitionDef.setProperties(title="""processFail""",
                                new_state_id="""failure""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""processFail""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['validationSucceed']
    transitionDef.setProperties(title="""validationSucceed""",
                                new_state_id="""validated""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""validationSucceed""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## State Variable
    workflow.variables.setStateVar('review_state')

    ## Variables initialization
    variableDef = workflow.variables['review_history']
    variableDef.setProperties(description="""Provides access to workflow history""",
                              default_value="""""",
                              default_expr="""state_change/getHistory""",
                              for_catalog=0,
                              for_status=0,
                              update_always=0,
                              props={'guard_permissions': 'Request review; Review portal content'})

    variableDef = workflow.variables['comments']
    variableDef.setProperties(description="""Comments about the last transition""",
                              default_value="""""",
                              default_expr="""python:state_change.kwargs.get('comment', '')""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['time']
    variableDef.setProperties(description="""Time of the last transition""",
                              default_value="""""",
                              default_expr="""state_change/getDateTime""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['actor']
    variableDef.setProperties(description="""The ID of the user who performed the last transition""",
                              default_value="""""",
                              default_expr="""user/getId""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['action']
    variableDef.setProperties(description="""The last transition""",
                              default_value="""""",
                              default_expr="""transition/getId|nothing""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    ## Worklists Initialization


    # WARNING: below protected section is deprecated.
    # Add a tagged value 'worklist' with the worklist name to your state(s) instead.

    ##code-section create-workflow-setup-method-footer #fill in your manual code here
    ##/code-section create-workflow-setup-method-footer



def createplonemall_payment_workflow(self, id):
    """Create the workflow for PloneMallPayment.
    """

    ob = DCWorkflowDefinition(id)
    setupplonemall_payment_workflow(self, ob)
    return ob

addWorkflowFactory(createplonemall_payment_workflow,
                   id='plonemall_payment_workflow',
                   title='plonemall_payment_workflow')

##code-section create-workflow-module-footer #fill in your manual code here
##/code-section create-workflow-module-footer

