# -*- coding: utf-8 -*-
#
# File: PloneMallPayment.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'


from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.PloneMallPayment.config import *

##code-section create-workflow-module-header #fill in your manual code here
##/code-section create-workflow-module-header


productname = 'PloneMallPayment'

def setupplonemall_redirecting_payment_workflow(self, workflow):
    """Define the plonemall_redirecting_payment_workflow workflow.
    """

    workflow.setProperties(title='plonemall_redirecting_payment_workflow')

    ##code-section create-workflow-setup-method-header #fill in your manual code here
    ##/code-section create-workflow-setup-method-header


    for s in ['processing', 'success', 'failed', 'confirmed', 'initialized', 'cancelled', 'created', 'aborted']:
        workflow.states.addState(s)

    for t in ['successProcessing', 'failureProcessing', 'abort', 'startProcessing', 'cancelProcessing', 'initializeProcessing']:
        workflow.transitions.addTransition(t)

    for v in ['review_history', 'comments', 'time', 'actor', 'action']:
        workflow.variables.addVariable(v)


    for l in []:
        if not l in workflow.worklists.objectValues():
            workflow.worklists.addWorklist(l)

    ## Initial State

    workflow.states.setInitialState('created')

    ## States initialization

    stateDef = workflow.states['processing']
    stateDef.setProperties(title="""processing""",
                           description="""""",
                           transitions=['cancelProcessing', 'successProcessing', 'failureProcessing'])

    stateDef = workflow.states['success']
    stateDef.setProperties(title="""success""",
                           description="""""",
                           transitions=[])

    stateDef = workflow.states['failed']
    stateDef.setProperties(title="""failed""",
                           description="""""",
                           transitions=[])

    stateDef = workflow.states['confirmed']
    stateDef.setProperties(title="""confirmed""",
                           description="""""",
                           transitions=[])

    stateDef = workflow.states['initialized']
    stateDef.setProperties(title="""initialized""",
                           description="""""",
                           transitions=['startProcessing'])

    stateDef = workflow.states['cancelled']
    stateDef.setProperties(title="""cancelled""",
                           description="""""",
                           transitions=[])

    stateDef = workflow.states['created']
    stateDef.setProperties(title="""created""",
                           description="""""",
                           transitions=['abort', 'initializeProcessing'])

    stateDef = workflow.states['aborted']
    stateDef.setProperties(title="""aborted""",
                           description="""""",
                           transitions=[])

    ## Transitions initialization

    ## Creation of workflow scripts
    for wf_scriptname in ['onSuccessProcessing']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.plonemall_redirecting_payment_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['successProcessing']
    transitionDef.setProperties(title="""successProcessing""",
                                new_state_id="""success""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""onSuccessProcessing""",
                                actbox_name="""successProcessing""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['onFailProcessing']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.plonemall_redirecting_payment_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['failureProcessing']
    transitionDef.setProperties(title="""failureProcessing""",
                                new_state_id="""failed""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""onFailProcessing""",
                                actbox_name="""failureProcessing""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['abort']
    transitionDef.setProperties(title="""abort""",
                                new_state_id="""aborted""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""abort""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['onStartProcessing']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.plonemall_redirecting_payment_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['startProcessing']
    transitionDef.setProperties(title="""startProcessing""",
                                new_state_id="""processing""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""onStartProcessing""",
                                actbox_name="""startProcessing""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['onAbort']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.plonemall_redirecting_payment_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['cancelProcessing']
    transitionDef.setProperties(title="""cancelProcessing""",
                                new_state_id="""cancelled""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""onAbort""",
                                actbox_name="""cancelProcessing""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    transitionDef = workflow.transitions['initializeProcessing']
    transitionDef.setProperties(title="""initializeProcessing""",
                                new_state_id="""initialized""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""""",
                                actbox_name="""initializeProcessing""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={},
                                )

    ## State Variable
    workflow.variables.setStateVar('review_state')

    ## Variables initialization
    variableDef = workflow.variables['review_history']
    variableDef.setProperties(description="""Provides access to workflow history""",
                              default_value="""""",
                              default_expr="""state_change/getHistory""",
                              for_catalog=0,
                              for_status=0,
                              update_always=0,
                              props={'guard_permissions': 'Request review; Review portal content'})

    variableDef = workflow.variables['comments']
    variableDef.setProperties(description="""Comments about the last transition""",
                              default_value="""""",
                              default_expr="""python:state_change.kwargs.get('comment', '')""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['time']
    variableDef.setProperties(description="""Time of the last transition""",
                              default_value="""""",
                              default_expr="""state_change/getDateTime""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['actor']
    variableDef.setProperties(description="""The ID of the user who performed the last transition""",
                              default_value="""""",
                              default_expr="""user/getId""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['action']
    variableDef.setProperties(description="""The last transition""",
                              default_value="""""",
                              default_expr="""transition/getId|nothing""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    ## Worklists Initialization


    # WARNING: below protected section is deprecated.
    # Add a tagged value 'worklist' with the worklist name to your state(s) instead.

    ##code-section create-workflow-setup-method-footer #fill in your manual code here
    ##/code-section create-workflow-setup-method-footer



def createplonemall_redirecting_payment_workflow(self, id):
    """Create the workflow for PloneMallPayment.
    """

    ob = DCWorkflowDefinition(id)
    setupplonemall_redirecting_payment_workflow(self, ob)
    return ob

addWorkflowFactory(createplonemall_redirecting_payment_workflow,
                   id='plonemall_redirecting_payment_workflow',
                   title='plonemall_redirecting_payment_workflow')

##code-section create-workflow-module-footer #fill in your manual code here
##/code-section create-workflow-module-footer

