# -*- coding: utf-8 -*-
#
# File: PayPalPaymentInformation.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallPayment.RedirectingPaymentInformation import RedirectingPaymentInformation
from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

PayPalPaymentInformation_schema = BaseSchema.copy() + \
    getattr(RedirectingPaymentInformation, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
##/code-section after-schema

class PayPalPaymentInformation(BaseContent, RedirectingPaymentInformation):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(RedirectingPaymentInformation,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'PayPalPaymentInformation'

    meta_type = 'PayPalPaymentInformation'
    portal_type = 'PayPalPaymentInformation'
    allowed_content_types = [] + list(getattr(RedirectingPaymentInformation, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'PayPalPaymentInformation.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "PayPalPaymentInformation"
    typeDescMsgId = 'description_edit_paypalpaymentinformation'

    _at_rename_after_creation = False

    schema = PayPalPaymentInformation_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declarePublic('getPaymentParameters')
    def getPaymentParameters(self):
        """
        returns a dictionary of parameters that will be passed to the
        clearing page.
        intended to be overloaded by  the concrete payment driver
        """
        portal=self.portal_url.getPortalObject()
        settings=self.getSettings()
        if not settings:
            raise ValueError,'no settings defined for %s' % self.getMethodName()

        customer=self.getCustomer()
        customer_address=customer.getAddress()

        res = {"cmd"           : "_xclick",
             "upload"        : "1",
             "business"      : settings.getBusiness(),
             "email"         : customer.getEmail(),
             "first_name"    : customer.getFirstname(),
             "last_name"     : customer.getLastname(),
             "address1"      : customer_address.getAddress1(),
             "address2"      : customer_address.getAddress2(),
             "zip"           : customer_address.getPostal_code(),
             "city"          : customer_address.getCity(),
             "state"         : customer_address.getState(),
             "country"       : customer_address.getCountry(),
             "amount"        : float(self.getTotal()),
             "currency_code" : self.getCurrency(),
             "invoice"       : self.getOrderNumber(),
             "item_number"   : self.getOrderNumber(),
             "item_name"     : self.getOrderNumber(),
             "no_shipping"   : "1",
             "return"        : self.absolute_url()+'/callbackSuccess',
             "cancel_return" : self.absolute_url()+'/callbackCancel'
             }

        return res

    security.declarePublic('getPaymentPageBaseUrl')
    def getPaymentPageBaseUrl(self):
        """

        """
        return "https://www.paypal.com/cgi-bin/webscr"



registerType(PayPalPaymentInformation, PROJECTNAME)
# end of class PayPalPaymentInformation

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('PayPalPaymentInformation', PayPalPaymentInformation)
##/code-section module-footer



