# -*- coding: utf-8 -*-
#
# File: PayPalSettings.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallPayment.RedirectingPaymentSettings import RedirectingPaymentSettings
from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry

##/code-section module-header

schema = Schema((

    StringField(
        name='merchantkey',
        widget=StringWidget(
            label='Merchantkey',
            label_msgid='PloneMallPayment_label_merchantkey',
            i18n_domain='PloneMallPayment',
        )
    ),

    ComputedField(
        name='business',
        widget=ComputedField._properties['widget'](
            label='Business',
            label_msgid='PloneMallPayment_label_business',
            i18n_domain='PloneMallPayment',
        ),
        expression="context.getMerchantkey()"
    ),

    StringField(
        name='baseUrl',
        default="https://www.paypal.com/cgi-bin/webscr",
        widget=StringWidget(
            label="Base URL",
            label_msgid='PloneMallPayment_label_baseUrl',
            i18n_domain='PloneMallPayment',
        )
    ),

    StringField(
        name='payment_method',
        default='PayPalPayment',
        widget=StringWidget(
            label='Payment_method',
            label_msgid='PloneMallPayment_label_payment_method',
            i18n_domain='PloneMallPayment',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

PayPalSettings_schema = BaseSchema.copy() + \
    getattr(RedirectingPaymentSettings, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PayPalSettings(BaseContent, RedirectingPaymentSettings):
    """PayPal Settings
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(RedirectingPaymentSettings,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'PayPalSettings'

    meta_type = 'PayPalSettings'
    portal_type = 'PayPalSettings'
    allowed_content_types = [] + list(getattr(RedirectingPaymentSettings, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'PayPalSettings.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "PayPalSettings"
    typeDescMsgId = 'description_edit_paypalsettings'

    _at_rename_after_creation = False

    schema = PayPalSettings_schema

    ##code-section class-header #fill in your manual code here
    icon_file='paypal.png'
    ##/code-section class-header

    # Methods

    # Manually created methods

    def getPaymentMethodName(self):
        return self.getPayment_method()



registerType(PayPalSettings, PROJECTNAME)
# end of class PayPalSettings

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('PayPalSettings', PayPalSettings)

##/code-section module-footer



