# -*- coding: utf-8 -*-
#
# File: PaymentSettings.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallRegistry.IPaymentSettings import IPaymentSettings
from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
##/code-section module-header

copied_fields = {}
copied_fields['title'] = BaseSchema['title'].copy()
copied_fields['title'].default = "Cash on Delivery"
schema = Schema((

    copied_fields['title'],
        StringField(
        name='payment_method',
        default="CashOnDelivery",
        widget=StringWidget(
            label='Payment_method',
            label_msgid='PloneMallPayment_label_payment_method',
            i18n_domain='PloneMallPayment',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

PaymentSettings_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PaymentSettings(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IPaymentSettings,)

    # This name appears in the 'add' box
    archetype_name = 'PaymentSettings'

    meta_type = 'PaymentSettings'
    portal_type = 'PaymentSettings'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'PaymentSettings.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "PaymentSettings"
    typeDescMsgId = 'description_edit_paymentsettings'

    _at_rename_after_creation = False

    schema = PaymentSettings_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getPaymentMethodName')
    def getPaymentMethodName(self):
        """
        """
        return self.getPayment_method()


registerType(PaymentSettings, PROJECTNAME)
# end of class PaymentSettings

##code-section module-footer #fill in your manual code here
##/code-section module-footer



