# -*- coding: utf-8 -*-
#
# File: PaymentSettingsTool.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *

from Products.Archetypes.AllowedTypesByIface import AllowedTypesByIfaceMixin
from Products.PloneMallRegistry.IPaymentSettings import IPaymentSettings
from Products.PloneMallPayment.config import *


from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

PaymentSettingsTool_schema = BaseFolderSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PaymentSettingsTool(UniqueObject, AllowedTypesByIfaceMixin, BaseFolder):
    """Payment Settings Tool
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(AllowedTypesByIfaceMixin,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'PaymentSettingsTool'

    meta_type = 'PaymentSettingsTool'
    portal_type = 'PaymentSettingsTool'
    allowed_content_types = []
    allowed_interfaces = [IPaymentSettings] 
    filter_content_types = 1
    global_allow = 0
    #content_icon = 'PaymentSettingsTool.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "PaymentSettingsTool"
    typeDescMsgId = 'description_edit_paymentsettingstool'
    #toolicon = 'PaymentSettingsTool.gif'

    _at_rename_after_creation = False

    schema = PaymentSettingsTool_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseFolder.__init__(self,'portal_paymentsettings')
        self.setTitle('PaymentSettingsTool')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer


    # tool should not appear in portal_catalog
    def at_post_edit_script(self):
        self.unindexObject()
        
        ##code-section post-edit-method-footer #fill in your manual code here
        ##/code-section post-edit-method-footer


    # Methods

    # Manually created methods

    def view(self,*a,**kw):
        '''circumvent plone bug that view doesnt redirect to the correct view method'''
        return self.base_view(*a,**kw)



registerType(PaymentSettingsTool, PROJECTNAME)
# end of class PaymentSettingsTool

##code-section module-footer #fill in your manual code here
##/code-section module-footer



