# -*- coding: utf-8 -*-
#
# File: QentaPaymentInformation.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallPayment.RedirectingPaymentInformation import RedirectingPaymentInformation
from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
import md5
##/code-section module-header

schema = Schema((

    StringField(
        name='fingerprint',
        widget=StringWidget(
            label='Fingerprint',
            label_msgid='PloneMallPayment_label_fingerprint',
            i18n_domain='PloneMallPayment',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

QentaPaymentInformation_schema = BaseSchema.copy() + \
    getattr(RedirectingPaymentInformation, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class QentaPaymentInformation(BaseContent, RedirectingPaymentInformation):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(RedirectingPaymentInformation,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'QentaPaymentInformation'

    meta_type = 'QentaPaymentInformation'
    portal_type = 'QentaPaymentInformation'
    allowed_content_types = [] + list(getattr(RedirectingPaymentInformation, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'QentaPaymentInformation.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "QentaPaymentInformation"
    typeDescMsgId = 'description_edit_qentapaymentinformation'

    _at_rename_after_creation = False

    schema = QentaPaymentInformation_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getPaymentParameters')
    def getPaymentParameters(self):
        """
        returns a dictionary of parameters that will be passed to the
        clearing page.
        intended to be overloaded by  the concrete payment driver
        """
        portal=self.portal_url.getPortalObject()
        settings=self.getSettings()
        if not settings:
            raise ValueError,'no settings defined for %s' % self.getMethodName()

        language='en'

        #if hasattr(self,'portal_languages'):
        #    language=self.portal_languages.getPreferredLanguage()

        res={
            'imageURL': settings.getImageURL() or portal.absolute_url()+'/'+portal.base_properties.logoName,
            'merchantKey':settings.getMerchantkey(),
            #'secret':settings.getSecret(),
            'currency':self.getCurrency(),
            'amount':float(self.getTotal()),
            'language':language,
            'successURL':self.absolute_url()+'/callbackSuccess',
            'failureURL':self.absolute_url()+'/callbackFailure',
            'cancelURL':self.absolute_url()+'/callbackCancel',
            'serviceURL':self.absolute_url(),
            'paymentType':settings.getDefaultPaymentType(),
            'orderDescription':self.getOrder().getOrderNumber(),
        }

        strFingerprint=str(res['merchantKey']) + str(res['amount']) + str(res['currency']) + \
                str(res['language']) + str(res['orderDescription']) + res['successURL'] + \
                res['failureURL'] + res['cancelURL'] + res['serviceURL'] + \
                res['imageURL'] + settings.getSecret()

        fingerprint=md5.new(strFingerprint).hexdigest()
        res['requestFingerprint']=fingerprint
        self.update(fingerprint=fingerprint)

        return res

    security.declarePublic('getPaymentPageBaseUrl')
    def getPaymentPageBaseUrl(self):
        """

        """
        return 'https://www.qenta.com/qpay/init-v21.php'


registerType(QentaPaymentInformation, PROJECTNAME)
# end of class QentaPaymentInformation

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('QentaPaymentInformation', QentaPaymentInformation)
##/code-section module-footer



