# -*- coding: utf-8 -*-
#
# File: QentaSettings.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallPayment.RedirectingPaymentSettings import RedirectingPaymentSettings
from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    StringField(
        name='merchantkey',
        widget=StringWidget(
            label='Merchantkey',
            label_msgid='PloneMallPayment_label_merchantkey',
            i18n_domain='PloneMallPayment',
        )
    ),

    StringField(
        name='secret',
        widget=StringWidget(
            label='Secret',
            label_msgid='PloneMallPayment_label_secret',
            i18n_domain='PloneMallPayment',
        )
    ),

    StringField(
        name='defaultPaymentType',
        default="CCARD",
        widget=StringWidget(
            label='Defaultpaymenttype',
            label_msgid='PloneMallPayment_label_defaultPaymentType',
            i18n_domain='PloneMallPayment',
        )
    ),

    StringField(
        name='baseUrl',
        default="http://www.qenta.com/paymentcenter/",
        widget=StringWidget(
            label='Baseurl',
            label_msgid='PloneMallPayment_label_baseUrl',
            i18n_domain='PloneMallPayment',
        )
    ),

    StringField(
        name='payment_method',
        default='QentaPayment',
        widget=StringWidget(
            label='Payment_method',
            label_msgid='PloneMallPayment_label_payment_method',
            i18n_domain='PloneMallPayment',
        )
    ),

    StringField(
        name='imageURL',
        widget=StringWidget(
            label='Imageurl',
            label_msgid='PloneMallPayment_label_imageURL',
            i18n_domain='PloneMallPayment',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

QentaSettings_schema = BaseSchema.copy() + \
    getattr(RedirectingPaymentSettings, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class QentaSettings(BaseContent, RedirectingPaymentSettings):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(RedirectingPaymentSettings,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'QentaSettings'

    meta_type = 'QentaSettings'
    portal_type = 'QentaSettings'
    allowed_content_types = [] + list(getattr(RedirectingPaymentSettings, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'QentaSettings.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "QentaSettings"
    typeDescMsgId = 'description_edit_qentasettings'

    _at_rename_after_creation = False

    schema = QentaSettings_schema

    ##code-section class-header #fill in your manual code here
    icon_file='visamaster.gif'
    ##/code-section class-header

    # Methods

    # Manually created methods

    def getPaymentMethodName(self):
        return self.getPayment_method()



registerType(QentaSettings, PROJECTNAME)
# end of class QentaSettings

##code-section module-footer #fill in your manual code here
##/code-section module-footer



