# -*- coding: utf-8 -*-
#
# File: RedirectingPaymentInformation.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallPayment.PaymentInformation import PaymentInformation
from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
import urllib
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.CMFCore.utils import getToolByName
##/code-section module-header

schema = Schema((

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

RedirectingPaymentInformation_schema = BaseSchema.copy() + \
    getattr(PaymentInformation, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class RedirectingPaymentInformation(BaseContent, PaymentInformation):
    """<p></p>
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(PaymentInformation,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'RedirectingPaymentInformation'

    meta_type = 'RedirectingPaymentInformation'
    portal_type = 'RedirectingPaymentInformation'
    allowed_content_types = [] + list(getattr(PaymentInformation, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'RedirectingPaymentInformation.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "RedirectingPaymentInformation"
    typeDescMsgId = 'description_edit_redirectingpaymentinformation'

    _at_rename_after_creation = False

    schema = RedirectingPaymentInformation_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('processPayment')
    def processPayment(self):
        """

        """
        #import pdb;pdb.set_trace()
        self.changeState('initializeProcessing')
        if self.getOptionsPage():
            #the answer of this page will be routed to redirectPaymentAction
            return self.showOptionsPage()
        else:
            #no further options to deal with, so lets redirect now
            return self.redirectPayment()

    security.declarePublic('callbackSuccess')
    def callbackSuccess(self,REQUEST):
        """

        """
        self.changeState('successProcessing')
        self.getOrder().notifyChanged(self)

        #XXX is not yet finished
        if REQUEST:
            return REQUEST.RESPONSE.redirect(self.aq_parent.absolute_url()+ \
                '/afterCheckout')
        return self.portal_workflow.getInfoFor(self,'review_state')

    security.declarePublic('callbackFailure')
    def callbackFailure(self,REQUEST):
        """

        """
        self.changeState('failureProcessing')
        self.getOrder().notifyChanged(self)

        #XXX is not yet finished
        if REQUEST:
            return REQUEST.RESPONSE.redirect(self.aq_parent.absolute_url()+ \
                '/afterCheckout')

        return self.portal_workflow.getInfoFor(self,'review_state')

    security.declarePublic('callbackCancel')
    def callbackCancel(self,REQUEST):
        """

        """
        self.changeState('cancelProcessing')
        self.getOrder().notifyChanged(self)

        #XXX is not yet finished
        if REQUEST:
            return REQUEST.RESPONSE.redirect(self.aq_parent.absolute_url()+ \
                '/payment_cancelled')
        return self.portal_workflow.getInfoFor(self,'review_state')

    security.declarePublic('showOptionsPage')
    def showOptionsPage(self):
        """

        """
        page=self.getOptionsPage()
        if page:
            return page()

    security.declarePublic('getOptionsPage')
    def getOptionsPage(self):
        """
        returns the pagetemplate of the options page
        """
        id='plonemall_payment_options_%s' % self.getMethodName()
        if hasattr(self,id):
            return getattr(self,id)
        else:
            return None

    security.declarePublic('getPaymentParameters')
    def getPaymentParameters(self):
        """
        returns a dictionary of parameters that will be passed to the
        clearing page.
        intended to be overloaded by  the concrete payment driver
        """
        return {}

    security.declarePublic('getPaymentPageUrl')
    def getPaymentPageUrl(self,options={}):
        """

        """

        base=self.getPaymentPageBaseUrl().strip()
        pars=self.getPaymentParameters()
        pars.update(options)
        parstring=urllib.urlencode(pars)
        if base.endswith('?') or base.endswith('&'):
            res=base+parstring
        else:
            res=base+'?'+parstring

        return res

    security.declarePublic('redirectPayment')
    def redirectPayment(self,options={}):
        """

        """
        self.changeState('startProcessing')

        url=self.getPaymentPageUrl(options)
        return self.REQUEST.RESPONSE.redirect(url)

    security.declarePublic('redirectPaymentAction')
    def redirectPaymentAction(self,REQUEST):
        """
        Used when using an options page.
        """

        options=REQUEST.form
        return self.redirectPayment(options)

    security.declarePublic('getPaymentPageBaseUrl')
    def getPaymentPageBaseUrl(self):
        """
        returns the base Url of the payment provider page such as
        'www.paypal.com'
        """

        raise NotImplementedError('getPaymentPageBaseUrl')

    # Manually created methods

    def changeState(self,transition):
        wft=getToolByName(self,'portal_workflow')
        wft.doActionFor(self,transition)



registerType(RedirectingPaymentInformation, PROJECTNAME)
# end of class RedirectingPaymentInformation

##code-section module-footer #fill in your manual code here
FactoryRegistry.registerMallFactory('RedirectingPaymentInformation', RedirectingPaymentInformation)
##/code-section module-footer



