# -*- coding: utf-8 -*-
#
# File: RedirectingPaymentSettings.py
#
# Copyright (c) 2007 by BlueDynamics Alliance (Austria), Weimar Desenvolvimento
# e Consultoria em Informatica - Ltda (Brasil), Zettai.net LCC (United States)
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>,
Fabiano Weimar dos Santos <xiru@xiru.org>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.PloneMallPayment.PaymentSettings import PaymentSettings
from Products.PloneMallPayment.config import *

##code-section module-header #fill in your manual code here
from Products.PloneMallRegistry.MallRegistry import FactoryRegistry
from Products.PloneMallRegistry.IRedirectingPaymentMethod import IRedirectingPaymentMethod

##/code-section module-header

copied_fields = {}
copied_fields['title'] = BaseSchema['title'].copy()
copied_fields['title'].expression = "context.getId()"
copied_fields['title'].accessor = "Title"
copied_fields['title'].default_method = "getPayment_method"
schema = Schema((

    #the url of the payment privider clearing site
    StringField(
        name='baseUrl',
        widget=StringWidget(
            label='Baseurl',
            label_msgid='PloneMallPayment_label_baseUrl',
            i18n_domain='PloneMallPayment',
        )
    ),

    StringField(
        name='payment_method',
        widget=SelectionWidget
        (
            label='Payment_method',
            label_msgid='PloneMallPayment_label_payment_method',
            i18n_domain='PloneMallPayment',
        ),
        vocabulary='listRedirectingPaymentMethods'
    ),

    copied_fields['title'],
    ),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

RedirectingPaymentSettings_schema = BaseSchema.copy() + \
    getattr(PaymentSettings, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class RedirectingPaymentSettings(BaseContent, PaymentSettings):
    """the url of the payment privider clearing site
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (getattr(PaymentSettings,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'RedirectingPaymentSettings'

    meta_type = 'RedirectingPaymentSettings'
    portal_type = 'RedirectingPaymentSettings'
    allowed_content_types = [] + list(getattr(PaymentSettings, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'RedirectingPaymentSettings.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "RedirectingPaymentSettings"
    typeDescMsgId = 'description_edit_redirectingpaymentsettings'

    _at_rename_after_creation = False

    schema = RedirectingPaymentSettings_schema

    ##code-section class-header #fill in your manual code here
    icon_file=''
    ##/code-section class-header

    # Methods

    security.declarePublic('listRedirectingPaymentMethods')
    def listRedirectingPaymentMethods(self):
        """

        """
        return self.portal_mall_registry.getSupportedFactoryNames(IRedirectingPaymentMethod)


registerType(RedirectingPaymentSettings, PROJECTNAME)
# end of class RedirectingPaymentSettings

##code-section module-footer #fill in your manual code here
##/code-section module-footer



