# -*- coding: utf-8 -*-
#
# File: IPaymentInformation.py
#
# Copyright (c) 2006 by BlueDynamics Alliance, Austria
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Jens Klein <jens@bluedynamics.com>, Phil Auersperg <phil@bluedynamics.com>"""
__docformat__ = 'plaintext'

from Interface import Base


class IPaymentInformation(Base):
    """IPaymentInformation
    """

    # Methods

    def getMethodName():
        """
        Return the PaymentMethod name
        """

    def getPaymentTotal():
        """
        Return the payment total
        """

    def isPaymentProcessed():
        """
        Return true when the payment is processed
        """

    def isPaymentConfirmed():
        """
        Return true when the payment is confirmed
        """
        pass

    def getSettings():
        """
        Return the PaymentSettings for the PaymentMethod used
        """

    def processPayment():
        """
        Process payment
        """


# end of class IPaymentInformation

