from AccessControl import ClassSecurityInfo
from Products.Archetypes.Widget import MultiSelectionWidget
from Products.Archetypes.Widget import DecimalWidget
from Products.Archetypes.Registry import registerWidget

class LargeMultiSelectionWidget(MultiSelectionWidget):
    """
    Large MultiSelection Widget

    'Dict' based widget for improved performance when 
    used with large vocabularies
    """

    _properties = MultiSelectionWidget._properties.copy()
    _properties.update({
        'macro' : "large_multiselection_widget",
        })
    security = ClassSecurityInfo()

registerWidget(LargeMultiSelectionWidget,
               title='LargeMultiSelection',
               description='A faster MultiSelection widget for big vocabularies',
               used_for=('Products.Archetypes.Field.LinesField',)
               )


class DecimalL10nWidget(DecimalWidget):
    """
    Widget for FixedPointField, that gets the decimal point from the
    translation machinery
    """
    # TODO: other L10n stuff, like thousands seperator.
    _properties = DecimalWidget._properties.copy()
    _properties.update({
        'macro' : "decimall10n",
        })

    security = ClassSecurityInfo()

registerWidget(DecimalL10nWidget,
               title='DecimalL10n',
               description='With localised decimal point',
               used_for=('Products.Archetypes.Field.FixedPointField',)
               )
